Package com.google.android.exoplayer2.drm

## Interface DrmSession

- All Known Implementing Classes:
    `ErrorStateDrmSession`

      public interface DrmSession

  A DRM session.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `DrmSession.DrmSessionException` | Wraps the throwable which is the cause of the error state.
    `static interface` | `DrmSession.State` | The state of the DRM session.

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static int` | `STATE_ERROR` | The session has encountered an error.
    `static int` | `STATE_OPENED` | The session is open, but does not have keys required for decryption.
    `static int` | `STATE_OPENED_WITH_KEYS` | The session is open and has keys required for decryption.
    `static int` | `STATE_OPENING` | The session is being opened.
    `static int` | `STATE_RELEASED` | The session has been released.

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `acquire​(DrmSessionEventListener.EventDispatcher eventDispatcher)` | Increments the reference count.
    `CryptoConfig` | `getCryptoConfig()` | Returns a `CryptoConfig` for the open session, or null if called before the session has been opened or after it's been released.
    `DrmSession.DrmSessionException` | `getError()` | Returns the cause of the error state, or null if `getState()` is not `STATE_ERROR`.
    `byte[]` | `getOfflineLicenseKeySetId()` | Returns the key set id of the offline license loaded into this session, or null if there isn't one.
    `UUID` | `getSchemeUuid()` | Returns the DRM scheme UUID for this session.
    `@com.google.android.exoplayer2.drm.DrmSession.State int` | `getState()` | Returns the current state of the session, which is one of `STATE_ERROR`, `STATE_RELEASED`, `STATE_OPENING`, `STATE_OPENED` and `STATE_OPENED_WITH_KEYS`.
    `default boolean` | `playClearSamplesWithoutKeys()` | Returns whether this session allows playback of clear samples prior to keys being loaded.
    `Map<String,​String>` | `queryKeyStatus()` | Returns a map describing the key status for the session, or null if called before the session has been opened or after it's been released.
    `void` | `release​(DrmSessionEventListener.EventDispatcher eventDispatcher)` | Decrements the reference count.
    `static void` | `replaceSession​(DrmSession previousSession, DrmSession newSession)` | Acquires `newSession` then releases `previousSession`.
    `boolean` | `requiresSecureDecoder​(String mimeType)` | Returns whether this session requires use of a secure decoder for the given MIME type.

- - ### Field Detail

    - #### STATE_RELEASED

          static final int STATE_RELEASED

      The session has been released. This is a terminal state.
      See Also:
        Constant Field Values

    - #### STATE_ERROR

          static final int STATE_ERROR

      The session has encountered an error. `getError()` can be used to retrieve the cause. This is a terminal state.
      See Also:
        Constant Field Values

    - #### STATE_OPENING

          static final int STATE_OPENING

      The session is being opened.
      See Also:
        Constant Field Values

    - #### STATE_OPENED

          static final int STATE_OPENED

      The session is open, but does not have keys required for decryption.
      See Also:
        Constant Field Values

    - #### STATE_OPENED_WITH_KEYS

          static final int STATE_OPENED_WITH_KEYS

      The session is open and has keys required for decryption.
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### replaceSession

          static void replaceSession​(@Nullable
                                     DrmSession previousSession,
                                     @Nullable
                                     DrmSession newSession)

      Acquires `newSession` then releases `previousSession`.

      Invokes `newSession's` `acquire(DrmSessionEventListener.EventDispatcher)` and `previousSession's` `release(DrmSessionEventListener.EventDispatcher)` in that order (passing `eventDispatcher = null`). Null arguments are ignored. Does nothing if `previousSession` and `newSession` are the same session.

    - #### getState

          @State
          @com.google.android.exoplayer2.drm.DrmSession.State int getState()

      Returns the current state of the session, which is one of `STATE_ERROR`, `STATE_RELEASED`, `STATE_OPENING`, `STATE_OPENED` and `STATE_OPENED_WITH_KEYS`.

    - #### playClearSamplesWithoutKeys

          default boolean playClearSamplesWithoutKeys()

      Returns whether this session allows playback of clear samples prior to keys being loaded.

    - #### getError

          @Nullable
          DrmSession.DrmSessionException getError()

      Returns the cause of the error state, or null if `getState()` is not `STATE_ERROR`.

    - #### getSchemeUuid

          UUID getSchemeUuid()

      Returns the DRM scheme UUID for this session.

    - #### getCryptoConfig

          @Nullable
          CryptoConfig getCryptoConfig()

      Returns a `CryptoConfig` for the open session, or null if called before the session has been opened or after it's been released.

    - #### queryKeyStatus

          @Nullable
          Map<String,​String> queryKeyStatus()

      Returns a map describing the key status for the session, or null if called before the session has been opened or after it's been released.

      Since DRM license policies vary by vendor, the specific status field names are determined by each DRM vendor. Refer to your DRM provider documentation for definitions of the field names for a particular DRM engine plugin.

      Returns:
        A map describing the key status for the session, or null if called before the session has been opened or after it's been released.
      See Also:
        `MediaDrm.queryKeyStatus(byte[])`

    - #### getOfflineLicenseKeySetId

          @Nullable
          byte[] getOfflineLicenseKeySetId()

      Returns the key set id of the offline license loaded into this session, or null if there isn't one.

    - #### requiresSecureDecoder

          boolean requiresSecureDecoder​(String mimeType)

      Returns whether this session requires use of a secure decoder for the given MIME type. Assumes a license policy that requires the highest level of security supported by the session.

      The session must be in `state` `STATE_OPENED` or `STATE_OPENED_WITH_KEYS`.

    - #### acquire

          void acquire​(@Nullable
                       DrmSessionEventListener.EventDispatcher eventDispatcher)

      Increments the reference count. When the caller no longer needs to use the instance, it must call `release(DrmSessionEventListener.EventDispatcher)` to decrement the reference count.
      Parameters:
        `eventDispatcher` - The `DrmSessionEventListener.EventDispatcher` used to route DRM-related events dispatched from this session, or null if no event handling is needed.

    - #### release

          void release​(@Nullable
                       DrmSessionEventListener.EventDispatcher eventDispatcher)

      Decrements the reference count. If the reference count drops to 0 underlying resources are released, and the instance cannot be re-used.
      Parameters:
        `eventDispatcher` - The `DrmSessionEventListener.EventDispatcher` to disconnect when the session is released (the same instance (possibly null) that was passed by the caller to `acquire(DrmSessionEventListener.EventDispatcher)`).